//+-----------------------------------------------------------------------+
//|                                                     Close EA v1.0.mq4 |
//|                                                          Skyline 2007 |
//|                                                                       |
//+-----------------------------------------------------------------------+
#property copyright "Skyline 2007"
#property link      ""
#include <stdlib.mqh>

//---- Definizione parametri esterni 
extern int       Slippage           = 3;   
extern double    Lots               = 0.1; 
extern bool      UseMoneyManagement = false;
extern int       Risk               = 2;
extern int       MagicNumber        = 11111;
extern int       PipsForEnter       = 15;
extern int       SundayCandleExists = true;

//----- Definizione parametri interni 


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   // Definizione Variabili
   double YesterdayHigh,YesterdayLow,YesterdayClose,TwoDaysAgoClose,Spread,SL,TP,Total;
   int    Ticket,Errore;
   
   // Calcola High/Low/Close del giorno precedente
   if (SundayCandleExists==true) // Se esiste la candela della domenica allora non la considera 
   {
    if (DayOfWeek()==1)
    {
     YesterdayHigh   = iHigh(NULL,PERIOD_D1,2);
     YesterdayLow    = iLow(NULL,PERIOD_D1,2);
     YesterdayClose  = iClose(NULL,PERIOD_D1,2);
     TwoDaysAgoClose = iClose(NULL,PERIOD_D1,3);
    }
    else
    {
     YesterdayHigh   = iHigh(NULL,PERIOD_D1,1);
     YesterdayLow    = iLow(NULL,PERIOD_D1,1);
     YesterdayClose  = iClose(NULL,PERIOD_D1,1);
     TwoDaysAgoClose = iClose(NULL,PERIOD_D1,2);     
    } 
   }
   else 
   {
    YesterdayHigh   = iHigh(NULL,PERIOD_D1,1);
    YesterdayLow    = iLow(NULL,PERIOD_D1,1);
    YesterdayClose  = iClose(NULL,PERIOD_D1,1);
    TwoDaysAgoClose = iClose(NULL,PERIOD_D1,2);    
   }   

    
   // Commenti vari //
   Comment("\nMax Lot allowed by broker = ",MarketInfo(Symbol(),MODE_MAXLOT),
           "\nMin Lot allowed by broker = ",MarketInfo(Symbol(),MODE_MINLOT));
   
   Total = OrdersTotal();
   if (Total < 1 && DayOfWeek()>=1 && DayOfWeek()<=5) 
   {
   // Controlla BUY Order
   if (
       //CheckBuyOrder()     ==0 && 
       ControllaBuyChiusi()==0 &&
       YesterdayClose >= TwoDaysAgoClose+PipsForEnter*Point
      )
     {   
      
      // Setta SL e TP 
      SL = CalcolaStopLoss("BUY",YesterdayLow);
      //if ((Ask-SL)/Point < MarketInfo(Symbol(),MODE_STOPLEVEL)) { SL = MarketInfo(Symbol(),MODE_STOPLEVEL);}
      
      // Calcola dimensione Lot in base all'Equity
      if (UseMoneyManagement==true) Lots = CalcolaLot(Risk);
      
      // Piazza l'ordine BUY
      Ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,0,"BUY ORDER",MagicNumber,0,Blue);
      if(Ticket<0)
      {
       Errore=GetLastError();
       Print("error BUY ORDER (",Errore,") : ",ErrorDescription(Errore));
      }  
     } 
      
     // Controlla SELL Order
     if (
         //CheckBuyOrder()     ==0 && 
         ControllaSellChiusi()==0 &&
         YesterdayClose <= TwoDaysAgoClose-PipsForEnter*Point
        )
     {
 
      // Setta SL 
      SL = CalcolaStopLoss("SELL",YesterdayHigh);
      //if (SL < MarketInfo(Symbol(),MODE_STOPLEVEL)) { SL = MarketInfo(Symbol(),MODE_STOPLEVEL);}
     
      // Calcola dimensione Lot in base all'Equity
      if (UseMoneyManagement==true) Lots = CalcolaLot(Risk);
      
      // Piazza Ordine SELL       
      Ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,0,"SELL ORDER",MagicNumber,0,Blue);
      if(Ticket<0)
      {
       Errore=GetLastError();
       Print("error SELL ORDER (",Errore,") : ",ErrorDescription(Errore));
      } 
     }    
   }
   
   // Sposta lo S/L 
   MovingStopLoss(YesterdayLow,YesterdayHigh);
 
   return(0);
  }

// ===== Routine per calcolare lo StopLoss =====
double CalcolaStopLoss(string Tipo, double YesterdayValue)
{
 if (Tipo=="BUY")
 {
  if ((Ask-YesterdayValue)/Point < MarketInfo(Symbol(),MODE_STOPLEVEL)) {return(Ask-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point);}
  else return(YesterdayValue);
 }
 if (Tipo=="SELL")
 {
  if ((Bid+YesterdayValue)/Point < MarketInfo(Symbol(),MODE_STOPLEVEL)) {return(Bid+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point);}
  else return(YesterdayValue);
 }
 
}

// ===== Routine per spostare lo StopLoss ===== 
void MovingStopLoss(double YesterdayLow, double YesterdayHigh)
{
 int cnt,err;
 double SL;
 int total = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber()==MagicNumber)
      {
       if (OrderType()==OP_BUY && Hour()==0 && Minute()==1)   // long position is opened
       {
        SL = CalcolaStopLoss("BUY",YesterdayLow); 
        if (OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,Green) == false)
        {
         err=GetLastError();
         if (err > 1) Print("error(",err,"): ",ErrorDescription(err));
        }
        else return(0);
       } // if(OrderType()==OP_BUY)  
       if(OrderType()==OP_SELL && Hour()==0 && Minute()==1)   // sell position is opened
       {
        SL = CalcolaStopLoss("SELL",YesterdayHigh); 
        if (OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,Red) == false)
        {
         err=GetLastError();
         if (err > 1) Print("error(",err,"): ",ErrorDescription(err));
        }
        else return(0);                     
       }// if(OrderType()==OP_SELL) 
      } // if (OrderMagicNumber...)    
    }  // for  
}


// ===== Routine per controllare BUY chiusi in giornata =====
int ControllaBuyChiusi()
{int i;
 int BuyChiusi=0;
 int hstTotal=HistoryTotal();
 for(i=0;i<hstTotal;i++)
 {
  //---- check selection result
  if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true)
  { 
   if (
       OrderType()==OP_BUY              && 
       TimeDay(OrderCloseTime())==Day() && 
       OrderMagicNumber()==MagicNumber   
      ) BuyChiusi++;
  } 
 }
 return(BuyChiusi);
}

// ===== Routine per controllare SELL chiusi in giornata =====
int ControllaSellChiusi()
{int i;
 int SellChiusi=0;
 int hstTotal=HistoryTotal();
 for(i=0;i<hstTotal;i++)
 {
  //---- check selection result
  if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==true)
  { 
   if (
       OrderType()==OP_SELL             && 
       TimeDay(OrderCloseTime())==Day() && 
       OrderMagicNumber()==MagicNumber 
      ) SellChiusi++;
  }  
 } 
 return(SellChiusi);
}

// ===== Routine per il calcolo del Lot nel caso di Money Management =====
double CalcolaLot(int Rischio)
{
  double Lot=0;
  Lot=AccountEquity()* Rischio/100/1000;
  if( Lot>=0.1 )
  {
    Lot = NormalizeDouble(Lot,1); 
  }
  else Lot = NormalizeDouble(Lot,2);
  if (Lot > MarketInfo(Symbol(),MODE_MAXLOT)) { Lot = MarketInfo(Symbol(),MODE_MAXLOT); } // Avoid possible Lot value overflow if lot exceed maximum value allowed by broker
  if (Lot < MarketInfo(Symbol(),MODE_MINLOT)) { Lot = MarketInfo(Symbol(),MODE_MINLOT); } // Avoid possible Lot value overflow if lot exceed minimum value allowed by broker
  return(Lot);
}

//+------------------------------------------------------------------+